<script lang="ts">
  import type { PlayerId, Settings, State } from "../../server";
  import { CardFace } from "../../server";
  import cardEmoji from "../cardEmoji";
  import { cardTitle } from "../util/cardUtils";
  import { createActionDispatcher } from "../util/createActionDispatcher";

  const dispatchAction = createActionDispatcher();

  export let actorId: PlayerId;
  export let state: State;
  export let settings: Settings;

  let otherPlayers = state.players.filter((p) => p.id !== actorId);

  let selectedCard: CardFace | null = null;
  let selectedPlayer: PlayerId | null = null;

  let guessableCards: CardFace[] =
    settings.mode === "Modern"
      ? [
          CardFace.C9,
          CardFace.C8,
          CardFace.C7,
          CardFace.C6,
          CardFace.C5,
          CardFace.C4,
          CardFace.C3,
          CardFace.C2,
          CardFace.C0,
        ]
      : [
          CardFace.C9,
          CardFace.C8,
          CardFace.C7,
          CardFace.C5,
          CardFace.C4,
          CardFace.C3,
          CardFace.C2,
        ];
</script>

<section>
  <h3>Guess a player's hand!</h3>
  <div class="inputs-wrapper">
    <ul>
      {#each otherPlayers as player (player.id)}
        <li>
          <label
            for="guess-target-{player.id}"
            class:disabled={player.hand.length === 0}
          >
            {#if player.protected}
              <span class="emoji">🛡</span>
            {:else}
              <input
                type="radio"
                name="guess-target"
                id="guess-target-{player.id}"
                disabled={player.hand.length === 0}
                bind:group={selectedPlayer}
                value={player.id}
              />
            {/if}
            <gs6-user playerid={player.id} />
          </label>
        </li>
      {/each}
    </ul>

    <ul>
      {#each guessableCards as card}
        <li>
          <label>
            <input
              type="radio"
              name="card"
              bind:group={selectedCard}
              value={card}
            />
            {cardEmoji(card)}
            {cardTitle(card)}
          </label>
        </li>
      {/each}
    </ul>
  </div>
  <button
    class="primary"
    disabled={selectedPlayer === null || selectedCard === null}
    on:click={() => {
      if (selectedPlayer !== null && selectedCard !== null) {
        dispatchAction({
          kind: "Guess",
          guess: selectedCard,
          target: selectedPlayer,
        });
      }
    }}
  >
    Guess!
  </button>
</section>

<style>
  section {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .inputs-wrapper {
    display: flex;
    align-items: center;
  }
  ul {
    margin-right: 1em;
    margin-left: 0.25em;
    white-space: nowrap;
    line-height: 1.7em;
  }
  .disabled {
    filter: grayscale(0.9) opacity(0.5);
  }
</style>
